apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  # name must match the spec fields below, and be in the form: <plural>.<group>
  name: airbytedestinations.airbytes.neux
spec:
  versions:
    - name: v1
      # Each version can be enabled/disabled by Served flag.
      served: true
      # One and only one version must be marked as the storage version.
      storage: true
      schema:
        openAPIV3Schema:
          type: object
          properties:
            status:
              type: object
              x-kubernetes-preserve-unknown-fields: true
            spec:
              type: object
              required: ["destination"]
              properties:
                destination:
                  maxProperties: 1
                  type: object
                  properties:
                    mongodb:
                      type: object
                      required: ["database", "instance_type", "auth_type"]
                      properties:
                        database: 
                          type: string
                        instance_type:
                          type: object
                          required: ["instance", "port", "host"]
                          properties:
                            instance: 
                              type: string
                            port:
                              type: integer
                              default: 27017
                            host:
                              type: string
                        auth_type:
                          type: object
                          properties:
                            authorization:
                              type: string
                            username:
                              type: string
                            password:
                              type: string
                        tunnel_method:
                          type: object
                          properties:
                            tunnel_method:
                              type: string
                              default: NO_TUNNEL
                workspace_id:
                  type: string
                destination_id:
                  type: string
          required: ["spec"]
  # group name to use for REST API: /apis/<group>/<version>
  group: airbytes.neux  
  # either Namespaced or Cluster
  scope: Namespaced 
  names:
   # plural name to be used in the URL: /apis/<group>/<version>/<plural>
   plural: airbytedestinations
   # singular name to be used as an alias on the CLI and for display
   singular: airbytedestination
   # kind is normally the CamelCased singular type. Your redestination manifests use this.
   kind: AirbyteDestination
   # shortNames allow shorter string to match your redestination on the CLI
   shortNames:
   - abdestination